package model

import (
	"gorm.io/plugin/soft_delete"
	"time"
)

// RealName 实名认证模型
type RealName struct {
	ID                 uint `gorm:"primarykey"`
	CreatedAt          time.Time
	UpdatedAt          time.Time
	DeletedAt          soft_delete.DeletedAt `gorm:"uniqueIndex:udx_name"`
	Name               string                `gorm:"column:name;comment:姓名" json:"name"`
	Sex                int                   `gorm:"column:sex;comment:性别:1男 2女" json:"sex"`
	Nationality        string                `gorm:"column:nationality;comment:国籍" json:"nationality"`
	DocumentType       int                   `gorm:"column:document_type;comment:证件类型:1护照 2身份证 3驾驶证 4居住证 5自拍照 6社保卡" json:"documentType"`
	CertificatePicture string                `gorm:"type:varchar(500);column:certificate_picture;comment:证件照片" json:"certificatePicture"`
	Validity           string                `gorm:"column:validity;comment:证件有效期" json:"validity"`
	PlaceOfResidence   string                `gorm:"column:place_of_residence;comment:居住地" json:"placeOfResidence"`
	GroupPhoto         string                `gorm:"column:group_photo;comment:证件合影" json:"groupPhoto"`
	Attachment         string                `gorm:"column:attachment;comment:附件" json:"attachment"`
}
